// 002 u_test_udf
// 21 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_test_udf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, DB, IBCustomDataSet, IBDatabase, Grids,
  DBGrids, ComCtrls, IBUpdateSQL, IBQuery, IBSQL, IBExtract;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Panel3: TPanel;
    Memo1: TMemo;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    DataSource1: TDataSource;
    display_table_ibquery_: TIBQuery;
    IBUpdateSQL1: TIBUpdateSQL;
    IBSQL1: TIBSQL;
    display_udf_ibquery_: TIBQuery;
    DataSource2: TDataSource;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    create_database_: TButton;
    create_udf_: TButton;
    display_udf_: TButton;
    drop_udf_: TButton;
    select_rpad_: TButton;
    IBExtract1: TIBExtract;
    select_rtrim_: TButton;
    add_table_: TButton;
    display_table_: TButton;
    drop_table_: TButton;
    select_strlen_: TButton;
    select_substr_: TButton;
    rtrim_: TButton;
    trim_edit_: TEdit;
    udf_ibquery_: TIBQuery;
    rpad_: TButton;
    substr_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure create_database_Click(Sender: TObject);
    procedure create_udf_Click(Sender: TObject);
    procedure display_udf_Click(Sender: TObject);
    procedure drop_udf_Click(Sender: TObject);
    procedure add_table_Click(Sender: TObject);
    procedure drop_table_Click(Sender: TObject);
    procedure display_table_Click(Sender: TObject);
    procedure select_rtrim_Click(Sender: TObject);
    procedure select_rpad_Click(Sender: TObject);
    procedure select_strlen_Click(Sender: TObject);
    procedure select_substr_Click(Sender: TObject);
    procedure rtrim_Click(Sender: TObject);
    procedure rpad_Click(Sender: TObject);
    procedure substr_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses u_c_log, u_c_display, u_file, u_dir
        , u_ibx
        , u_import_udf_string
        ;

    {$R *.DFM}

    // -- copy dll
  
    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // -- database

    const k_database_name= '..\_data\test_7\ib_test_7.gdb';
          k_user= 'SYSDBA';
          k_password= 'masterkey';

    procedure TForm1.create_database_Click(Sender: TObject);
      begin
        if f_create_ib_database(k_database_name, k_user, k_password, IbDataBase1)
          then display('ok_create_database');
      end; // create_database_Click

    // -- table

    const k_create_table=
                'CREATE TABLE training'
              + '  ('
              + '      f_id INTEGER'
              + '    , f_name CHAR(30)'
              + '    , f_location VARCHAR(10)'
              + '    , f_days INTEGER'
              + '    , f_price FLOAT'
              + '  )';

          k_insert_into_start= 'INSERT INTO training (f_id, f_name, f_location, f_days, f_price) VALUES ';
          k_select_training= 'SELECT * FROM training';
          k_drop_table= 'DROP TABLE training';

    procedure TForm1.add_table_Click(Sender: TObject);

      procedure create_table;
        begin
          display(k_create_table);
          if f_execute_ibsql(IbSql1, k_create_table)
            then display('ok_create_training');
        end; // create_table

      procedure fill_table;

        procedure add_row(p_values: String);
          begin
            if f_execute_ibsql(IbSql1, k_insert_into_start+ '('+ p_values+ ')')
              then display('  ok_row');
          end; // add_row

        begin // fill_table
          add_row('100, ''Interbase Client Server'', ''Paris'', 3, 1400');
          add_row('101, ''ADO.Net Sql Server'', ''London'', 3, 1400');
          add_row('102, ''ASP.Net Oracle'', ''Hong Kong'', 3, 1400');
          add_row('103, ''TCP / IP Interbase'', ''Montreal'', 3, 1400');
          add_row('104, ''Turbo Delphi Design Patterns'', ''Sao Paulo'', 3, 1400');
          add_row('105, ''Delphi OO Programming'', ''Dallas'', 3, 1400');
        end; // fill_table

      begin // add_table_Click
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              with IbSql1 do
              begin
                Close;
                Database:= IbDatabase1;
              end;

              create_table;
              fill_table;
            end; // db is open
      end;  // add_table_Click

    procedure TForm1.display_table_Click(Sender: TObject);
      begin
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              open_ibquery(display_table_ibquery_, k_select_training);
            end;
      end; // display_table_Click

    procedure TForm1.drop_table_Click(Sender: TObject);
      begin
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              with IbSql1 do
              begin
                Close;
                Database:= IbDatabase1;
              end;

              if f_execute_ibsql(IbSql1, k_drop_table)
                then display('ok_drop_training');
            end;
      end; // drop_table_Click

    // -- UDF

    const
          k_rpad= 'RPAD';
          k_strlen= 'STRLEN';
          k_substr= 'SUBSTR';
          k_rtrim= 'RTRIM';

          k_create_rpad=
              'DECLARE EXTERNAL FUNCTION '+ k_rpad
            + '  CSTRING(200), INTEGER, CSTRING(1)'
            + '  RETURNS CSTRING(80) FREE_IT'
            + '  ENTRY_POINT ''f_right_pad''  MODULE_NAME ''d_string_udf''';

          k_create_strlen=
              'DECLARE EXTERNAL FUNCTION '+ k_strlen
            + '  CSTRING(32767)'
            + '  RETURNS INTEGER BY VALUE'
            + '  ENTRY_POINT ''f_string_length''  MODULE_NAME ''d_string_udf''';

          k_create_rtrim=
              'DECLARE EXTERNAL FUNCTION '+ k_rtrim
            + '  CSTRING(80)'
            + '  RETURNS CSTRING(80) FREE_IT'
            + '  ENTRY_POINT ''f_trim_right''  MODULE_NAME ''d_string_udf''';
(*
          k_create_rtrim=
              'DECLARE EXTERNAL FUNCTION RTRIM'
            + '  CSTRING(80)'
            + '  RETURNS CSTRING(80) FREE_IT'
            + '  ENTRY_POINT ''IB_UDF_rtrim'' MODULE_NAME ''ib_udf''';

*)

          k_create_substr=
              'DECLARE EXTERNAL FUNCTION '+ k_substr
            + '  CSTRING(750), SMALLINT, SMALLINT'
            + '  RETURNS CSTRING(85) FREE_IT'
            + '  ENTRY_POINT ''f_sub_string''  MODULE_NAME ''d_string_udf''';

(*
          k_create_substr=
              'DECLARE EXTERNAL FUNCTION substr'
            + '  CSTRING(80), SMALLINT, SMALLINT'
            + '  RETURNS CSTRING(80) FREE_IT'
            + '  ENTRY_POINT ''IB_UDF_substr''  MODULE_NAME ''ib_udf''';
*)

    procedure TForm1.create_udf_Click(Sender: TObject);
      begin
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              with IbSql1 do
              begin
                Close;
                Database:= IbDatabase1;
              end;

              if f_execute_ibsql(IbSql1, k_create_rpad)
                then display('ok_rpad');
              if f_execute_ibsql(IbSql1, k_create_rtrim)
                then display('ok_rtrim');
              if f_execute_ibsql(IbSql1, k_create_strlen)
                then display('ok_strlen');
              if f_execute_ibsql(IbSql1, k_create_substr)
                then display('ok_substr');
            end;
      end; // create_udf_Click

    procedure TForm1.display_udf_Click(Sender: TObject);
        // -- extract all the stored procedures
      var l_item: Integer;
      begin
        display('> udf_calls');

        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);
        if f_open_ib_database('', IbDatabase1)
          then begin
              with IBExtract1 do
              begin
                ExtractObject(eoFunction, '');
                with Items do
                  for l_item:= 0 to Count- 1 do
                    display(Strings[l_item]);
              end; // with IBExtract1
            end;

        display('< udf_calls');
      end; // display_udf_Click

    const
          k_drop_rpad= 'DROP EXTERNAL FUNCTION '+ k_rpad;
          k_drop_rtrim= 'DROP EXTERNAL FUNCTION '+ k_rtrim;
          k_drop_strlen= 'DROP EXTERNAL FUNCTION '+ k_strlen;
          k_drop_substr= 'DROP EXTERNAL FUNCTION '+ k_substr;

    procedure TForm1.drop_udf_Click(Sender: TObject);
      begin
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              with IbSql1 do
              begin
                Close;
                Database:= IbDatabase1;
              end;

              if f_execute_ibsql(IbSql1, k_drop_rpad)
                then display('ok_rpad');
              if f_execute_ibsql(IbSql1, k_drop_rtrim)
                then display('ok_rtrim');
              if f_execute_ibsql(IbSql1, k_drop_strlen)
                then display('ok_strlen');
              if f_execute_ibsql(IbSql1, k_drop_substr)
                then display('ok_substr');
            end;
      end; // drop_udf_Click

    // -- use the udf's

    const k_add_right_spaces= 'UPDATE training '
             + ' SET '
             + '   f_name= f_name || ''   '' '
             + '   , f_location= f_location || ''   '' '
             + ' WHERE f_id= 100';
          // k_select_rtrim= 'SELECT F_NAME, RTRIM(F_NAME) FROM TRAINING WHERE f_id= 100';
          k_select_rtrim= 'SELECT F_LOCATION, RTRIM(F_LOCATION) FROM TRAINING WHERE f_id= 100';
          k_select_no_rtrim= 'SELECT F_LOCATION FROM TRAINING WHERE f_id= 100';
          k_select_rtrim_only= 'SELECT RTRIM(F_LOCATION) FROM TRAINING WHERE f_id= 100';
          k_select_rtrim_where= 'SELECT * FROM TRAINING WHERE f_location= RTRIM(''Paris   '')';
          k_select_rtrim_where_2= 'SELECT * FROM TRAINING WHERE f_location= ''  Paris   ''';
          k_select_rtrim_where_3= 'SELECT * FROM TRAINING WHERE f_location= RTRIM(''Hong    '') || '' '' || ''Kong'' ';
(*
          k_select_rtrim= 'SELECT F_NAME, RTRIM(F_NAME) '
             + '   , F_LOCATION, RTRIM(F_LOCATION) '
             + ' FROM TRAINING WHERE f_id= 100';
*)
    procedure TForm1.select_rtrim_Click(Sender: TObject);
      var l_rtrim_name, l_name: String;
      begin
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              // open_ibquery(display_udf_ibquery_, k_select_rtrim);

              // -- use an ibQuery not linked to a db_xxx
(*
              open_ibquery(udf_ibquery_, k_select_rtrim);
              l_name:= udf_ibquery_.Fields[0].AsString;
              l_rtrim_name:= udf_ibquery_.Fields[1].AsString;
              display(IntToStr(Length(l_name))+ ' |'+ l_name+ '|');
              display(IntToStr(Length(l_rtrim_name))+ ' |'+ l_rtrim_name+ '|');
*)
(*
              open_ibquery(udf_ibquery_, k_select_no_rtrim);
              l_name:= udf_ibquery_.Fields[0].AsString;
              display('no_rtrim '+ IntToStr(Length(l_name))+ ' |'+ l_name+ '|');

              open_ibquery(udf_ibquery_, k_select_rtrim_only);
              l_rtrim_name:= udf_ibquery_.Fields[0].AsString;
              display('with_rtrim '+ IntToStr(Length(l_rtrim_name))+ ' |'+ l_rtrim_name+ '|');

              open_ibquery(display_udf_ibquery_, k_select_rtrim_where);
*)
              open_ibquery(display_udf_ibquery_, k_select_rtrim_where_3);
            end;
      end; // select_rtrim_Click

    const // k_select_rpad= 'SELECT F_NAME, RPAD(F_NAME, 5, ''_'') FROM TRAINING'; // training WHERE f_id= 100';
          k_select_rpad= 'SELECT * FROM TRAINING WHERE f_location= RPAD(''Hong'', 1, '' '') || ''Kong'' '; // / training WHERE f_id= 100';

    procedure TForm1.select_rpad_Click(Sender: TObject);
      var l_rtrim_name, l_name: String;
      begin
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              open_ibquery(display_udf_ibquery_, k_select_rpad);

              l_name:= display_udf_ibquery_.Fields[0].AsString;
              l_rtrim_name:= display_udf_ibquery_.Fields[1].AsString;
              display(IntToStr(Length(l_name))+ ' |'+ l_name+ '|');
              display(IntToStr(Length(l_rtrim_name))+ ' |'+ l_rtrim_name+ '|');
            end;
      end; // select_rpad_Click

    const k_select_strlen= 'SELECT F_LOCATION, STRLEN(F_LOCATION) FROM TRAINING WHERE f_id= 105';

    procedure TForm1.select_strlen_Click(Sender: TObject);
      var l_rtrim_name, l_name: String;
      begin
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              open_ibquery(display_udf_ibquery_, k_select_strlen);

              l_name:= display_udf_ibquery_.Fields[0].AsString;
              l_rtrim_name:= display_udf_ibquery_.Fields[1].AsString;
              display(IntToStr(Length(l_name))+ ' |'+ l_name+ '|');
              display(l_rtrim_name);
            end;
      end; // select_strlen_Click

    const // k_select_substr= 'SELECT F_NAME, SUBSTR(F_NAME, 4, 2) FROM TRAINING';
          // k_select_substr= 'SELECT F_LOCATION, SUBSTR(F_LOCATION, 2, 5) FROM TRAINING WHERE F_ID= 101';
          // k_select_substr= 'SELECT * FROM TRAINING WHERE SUBSTR(F_LOCATION, 2, 3)= ''ntr'' ';
          k_select_substr= 'SELECT F_LOCATION, SUBSTR2(F_LOCATION, 2, 5) FROM TRAINING WHERE F_ID= 101';

    procedure TForm1.select_substr_Click(Sender: TObject);
      var l_rtrim_name, l_name: String;
      begin
        initialize_ib_database(k_database_name, k_user, k_password, IbDatabase1);

        if f_open_ib_database('', IbDatabase1)
          then begin
              display('ok_open');

              open_ibquery(display_udf_ibquery_, k_select_substr);

              l_name:= display_udf_ibquery_.Fields[0].AsString;
              l_rtrim_name:= display_udf_ibquery_.Fields[1].AsString;
              display(IntToStr(Length(l_name))+ ' |'+ l_name+ '|');
              display(IntToStr(Length(l_rtrim_name))+ ' |'+ l_rtrim_name+ '|');
            end;
      end; // select_substr_Click

    // -- trial of the routines in Delphi

    procedure TForm1.rtrim_Click(Sender: TObject);
      var l_string: String;
          l_trimmed_string: String;
      begin
        l_string:= '   '+ trim_edit_.Text+ '   ';
        display('string >'+ l_string+ '<');
        // l_string:= l_string+ chr(0);
        l_trimmed_string:= f_trim_right(pChar(@l_string[1]));
        display('trimmed_string >'+ l_trimmed_string+ '<');
      end; // rtrim_Click

    procedure TForm1.rpad_Click(Sender: TObject);

      function _f_rPad(p_pchar: PChar; var p_length: Integer; p_pad_pchar: PChar): PChar;
        var l_string, l_padded_string: String;
            l_padded_length, l_length, l_index: Integer;
        begin
          l_string:= String(p_pchar);
          l_length:= Length(l_string);
          l_padded_string:= String(p_pad_pchar);
          l_padded_length:= Length(l_padded_string);

          display('str >'+ l_string+ '< '+ IntToStr(l_length));
          display('pad >'+ l_padded_string+ '< '+ IntToStr(l_padded_length));

          if (l_length< p_length) and (l_padded_length<= p_length- l_length)
            then
              begin
                for l_index:= 1 to (p_length- l_length) div l_padded_length do
                  l_string:= l_string+ l_padded_string;
              end;

          // Result:= f_build_pchar(PChar(l_string), nil, 0);
          Result:= @ l_string[1];
        end; // _f_rPad

      var l_string: String;
          l_padding: String;
          l_rpad_string: String;
          l_count: Integer;

      begin // rpad_Click
        l_string:= '   '+ trim_edit_.Text+ '   ';
        display('string        >'+ l_string+ '<');
        // l_string:= l_string+ chr(0);
        l_padding:= '_';
        l_count:= 30;
        // l_rpad_string:= f_rPad(pChar(@l_string[1]), l_count, pChar(@l_padding[1]));
        l_rpad_string:= _f_rPad(pChar(@l_string[1]), l_count, pChar(@l_padding[1]));
        display('padded_string >'+ l_rpad_string+ '<');
      end; // rpad_Click

    procedure TForm1.substr_Click(Sender: TObject);
      var l_string: String;
          l_substring: String;
      begin
        l_string:= '   '+ trim_edit_.Text+ '   ';
        display('string >'+ l_string+ '<');
        // l_string:= l_string+ chr(0);
        l_substring:= f_sub_string(pChar(@l_string[1]), 5, 3);
        display('trimmed_string >'+ l_substring+ '<');
      end; // substr_Click

end.


